% Isto sao apenas propostas de solucao...

% -------------------------------------------------------
% 1) Analise lexica
% -------------------------------------------------------
analisa(F,LC):- see(F), read_file(L), seen, parse(LC,L,[]).

read_file(L):- get0(H), read_aux(H,L).
read_aux(-1,[]):-!.
read_aux(C,[C|L]):- read_file(L).

parse([num(N)|T]) --> number(L), {name(N,L)}, spaces, parse(T).
parse([pal(W)|T]) --> word(L), {name(W,L)}, spaces, parse(T).
parse([]) --> [].

spaces --> " ", spaces.
spaces --> "\n", spaces.
spaces --> [].

number([H|T]) --> digit(H), number(T), !.
number([H]) --> digit(H).

word([H|T]) --> letter(H), word(T), !.
word([H]) --> letter(H).

digit(C) --> [C], {C>="0", C=<"9"}.
letter(C) --> [C], {C>="a", C=<"z"}.
letter(C) --> [C], {C>="A", C=<"Z"}.

% -------------------------------------------------------
% 2) Expressoes aritmeticas
% -------------------------------------------------------
% Podia fazer-se completamente com gramaticas mas para mostrar o poder
% das bibliotecas usou-se o read_from_chars/2 e catch/3 (ver manual)
% Fica para exercicio vosso fazer... com gramaticas :-)
:- use_module(library(charsio)).
	
calcula(In,Out):- see(In), read_file(L), seen, tell(Out), lines(L,[]), told.

lines --> line(L), {calc(L)}, lines.
lines --> [].

line([46]) --> [10], !.       % Terminate with point to read_from_chars/2
line([H|T]) --> [H], line(T).

calc(L):-
	catch(read_from_chars(L,T),_, T = 1//0),
	catch(R is T,_, R  = 'expressao invalida'),
	write(R), nl.

% -------------------------------------------------------
% 3) Trocar maximo com minimo passando uma so vez
% -------------------------------------------------------
troca_maxmin([A,B|L],[HA,HB|R]):- !,
        maxmin(A,B,HA,HB,Max,Min),
        maxmin(L,Max,Min,R).
troca_maxmin(L,L).

maxmin(A,B,HA,HB,(A,HA),(B,HB)):- A>B.
maxmin(A,B,HA,HB,(B,HB),(A,HA)):- A<B.

% maxmin(Lista,(Maximo,VarSitioMaximo),(Minimo,VarSitioMinimo),NovaLista)
maxmin([],(Max,Min),(Min,Max),[]).
maxmin([H|T],(Max,Max),Min,[HMax|R]):- H>Max, !, maxmin(T,(H,HMax),Min,R).
maxmin([H|T],Max,(Min,Min),[HMin|R]):- H<Min, !, maxmin(T,Max,(H,HMin),R).
maxmin([H|T],Max,Min,[H|R]):- maxmin(T,Max,Min,R).


% -------------------------------------------------------
% 4) Trocar inteiros de sinal contrario numa dfs numa arvore
% -------------------------------------------------------
troca(A,NA):- troca(A,_,NA,(N,N)).

% troca(NoCorrente,(NumeroAnterior,VarSitioNumeroAnterior),NovaArvore)
troca(no(N,E,D),(Old,N),no(Old,NE,ND),T2):-
        integer(Old), N*Old<0, !,
        troca(E,_,NE,T1), troca(D,T1,ND,T2).
troca(no(N,E,D),(Old,Old),no(HN,NE,ND),T2):-
        troca(E,(N,HN),NE,T1), troca(D,T1,ND,T2).
troca([],T,[],T).
